#include "stdafx.h"
#include "m2jz.h"

// CM2jz
//
//   mgc2jz.dll [hNXł
//
CM2jz::CM2jz()
{
	Load();
}

CM2jz::~CM2jz()
{
	Unload();
}

// CM2jz o֐
void CM2jz::Load(void)
{
	m_hMJZ = LoadLibrary(_T("mgc2jz.dll"));

	if(m_hMJZ != NULL) 
	{
		Add				= (LPMJZADD)GetProcAddress(m_hMJZ, "mjzAdd");
		CheckForFigures	= (LPMJZCHECKFORFIGURES)GetProcAddress(m_hMJZ, "mjzCheckForFigures");
		CheckForZero	= (LPMJZCHECKFORZERO)GetProcAddress(m_hMJZ, "mjzCheckForZero");
		Compare			= (LPMJZCOMPARE)GetProcAddress(m_hMJZ, "mjzCompare");
		Divide			= (LPMJZDIVIDE)GetProcAddress(m_hMJZ, "mjzDivide");
		GetFigures		= (LPMJZGETFIGURES)GetProcAddress(m_hMJZ, "mjzGetFigures");
		Multiply		= (LPMJZMULTIPLY)GetProcAddress(m_hMJZ, "mjzMultiply");
		Power			= (LPMJZPOWER)GetProcAddress(m_hMJZ, "mjzPower");
		RemoveZero		= (LPMJZREMOVEZERO)GetProcAddress(m_hMJZ, "mjzRemoveZero");
		ShiftToLeft		= (LPMJZSHIFTTOLEFT)GetProcAddress(m_hMJZ, "mjzShiftToLeft");
		ShiftToRight	= (LPMJZSHIFTTORIGHT)GetProcAddress(m_hMJZ, "mjzShiftToRight");

		GetFileVersion	= (LPMJZGETFILEVERSION)GetProcAddress(m_hMJZ, "mjzGetFileVersion");

		DWORD dwMajor = 0;
		INT	  nR = GetFileVersion(_T("mgc2jz.dll"), &dwMajor, NULL, NULL, NULL);
	
		if(nR != SUCCESS  ||  dwMajor != 2)
		{
			Unload();
		}
	}
}

void CM2jz::Unload(void)
{
	if(m_hMJZ != NULL) 
	{
		BOOL bR = FreeLibrary(m_hMJZ);

		Add				= NULL;
		CheckForFigures	= NULL;
		CheckForZero	= NULL;
		Compare			= NULL;
		Divide			= NULL;
		GetFigures		= NULL;
		Multiply		= NULL;
		Power			= NULL;
		RemoveZero		= NULL;
		ShiftToLeft		= NULL;
		ShiftToRight	= NULL;

		GetFileVersion	= NULL;
	}
}

int CM2jz::AreYouReady(void)
{
	return (m_hMJZ != NULL)? YES : NO;
}