#pragma once

// CM2jz R}h ^[Qbg
//
//  mgc2jz.dll [hNXł (ver.2.1700)
//	
class CM2jz : public CObject
{
public:
	CM2jz();
	virtual ~CM2jz();
	
public:
	static const INT SUCCESS = 0;
	static const INT FAILURE = -1;
	static const INT YES	 = 1;
	static const INT NO		 = 0;

	static const ULONG	SIGNIFICANT_NUMBER	= 1000000000;	// L
	static const ULONG	SIGNIFICANT_FIGURES	= 9;			// L
	static const ULONG	MAX_NUMBER			= 999999999;	// zvfgől

	static const ULONG MIN_SIZE_OF_ELEMENTS	= 3;
	static const ULONG MAX_SIZE_OF_ELEMENTS	= 0xffff0000;
	static const ULONG SIGN_POINTER			= 0;
	static const ULONG RESERVED_POINTER		= 1;
	static const ULONG NUMERICAL_POINTER	= 2;
	static const ULONG NEGATIVE  = 1;
	static const ULONG POSITIVE	 = 0; 
	static const ULONG RESERVED	 = 0; 

	// error  0xffffffff - 0xffff0000 g 
	static const ULONG ERR_MIN_SIZE			= MAX_SIZE_OF_ELEMENTS;
	static const ULONG ERR_BAD_CONDITIONS	= 0xfffffffc;
	static const ULONG ERR_INDETERMINATE	= 0xfffffffd;
	static const ULONG ERR_MEMORY			= 0xfffffffe;
	static const ULONG ERR_OVERFLOW			= 0xffffffff;


	void Load(void);
	void Unload(void);
	int	 AreYouReady(void);

	//
	////  ֐`
	//
	typedef INT		(CALLBACK* LPMJZCOMPARE)(ULONG nDa[], ULONG nNa, ULONG nDb[], ULONG nNb);
	typedef ULONG	(CALLBACK* LPMJZADD)(ULONG nDa[], ULONG nNa, ULONG nDb[], ULONG nNb);
	typedef ULONG	(CALLBACK* LPMJZCHECKFORFIGURES)(ULONG nDa[], ULONG nNa, ULONG nFigures);
	typedef ULONG	(CALLBACK* LPMJZCHECKFORZERO)(ULONG nDa[], ULONG nNa);
	typedef ULONG	(CALLBACK* LPMJZDIVIDE)(	ULONG nDa[],
												ULONG nNa, 
												ULONG nDb[],
												ULONG nNb, 
												ULONG nDc[],
												ULONG nNc);
	typedef ULONG	(CALLBACK* LPMJZGETFIGURES)(ULONG nDa[], ULONG nNa);
	typedef ULONG	(CALLBACK* LPMJZMULTIPLY)(	ULONG nDa[], 
												ULONG nNa,
												ULONG nDb[], 
												ULONG nNb,
												ULONG nDc[],
												ULONG nNc	);
	typedef ULONG	(CALLBACK* LPMJZPOWER)(	ULONG nBase[], 
											ULONG nNb,
											LONG nPower,
											ULONG nAnswer[],
											ULONG nNa	);
	typedef ULONG	(CALLBACK* LPMJZREMOVEZERO)(ULONG nDa[], ULONG nNa);
	typedef ULONG	(CALLBACK* LPMJZSHIFTTOLEFT)(ULONG nDa[], ULONG nNa, ULONG nExpression);
	typedef ULONG	(CALLBACK* LPMJZSHIFTTORIGHT)(ULONG nDa[], ULONG nNa, ULONG nExpression);

	typedef INT		(CALLBACK* LPMJZGETFILEVERSION)( LPCWSTR lpszFile, 
													 DWORD*	lpdwMajor,
													 DWORD*	lpdwMinor,
													 DWORD*	lpdwRevision,
													 DWORD* lpdwBild	);
	LPMJZADD				Add;
	LPMJZCHECKFORFIGURES	CheckForFigures;
	LPMJZCHECKFORZERO		CheckForZero;
	LPMJZCOMPARE			Compare;
	LPMJZDIVIDE				Divide;
	LPMJZGETFIGURES			GetFigures;
	LPMJZMULTIPLY			Multiply;
	LPMJZPOWER				Power;
	LPMJZREMOVEZERO			RemoveZero;
	LPMJZSHIFTTOLEFT		ShiftToLeft;
	LPMJZSHIFTTORIGHT		ShiftToRight;

	LPMJZGETFILEVERSION	GetFileVersion;

private:
	HMODULE m_hMJZ;
};