Imports System.Runtime.InteropServices

Module m2jz
    '//
    '//// mgc2jz.dll  Header Ver2.1700a
    '//

    Public Const MJZ_SUCCESS As Integer = 0
    Public Const MJZ_FAILURE As Integer = -1
    Public Const MJZ_YES As Integer = 1
    Public Const MJZ_NO As Integer = 0

    Public Const MJZ_SIGNIFICANT_NUMBER As UInteger = 1000000000 '// L
    Public Const MJZ_SIGNIFICANT_FIGURES As UInteger = 9         '// L
    Public Const MJZ_MAX_NUMBER As UInteger = 999999999          '// zvfgől

    Public Const MJZ_MIN_SIZE_OF_ELEMENTS As UInteger = 3
    Public Const MJZ_MAX_SIZE_OF_ELEMENTS As UInteger = &HFFFF0000UL
    Public Const MJZ_SIGN_POINTER As UInteger = 0
    Public Const MJZ_RESERVED_POINTER As UInteger = 1
    Public Const MJZ_NUMERICAL_POINTER As UInteger = 2
    Public Const MJZ_NEGATIVE As UInteger = 1
    Public Const MJZ_POSITIVE As UInteger = 0
    Public Const MJZ_RESERVED As UInteger = 0

    '// error  &Hffffffff - &Hffff0000 g 
    Public Const MJZ_ERR_MIN_SIZE As UInteger = MJZ_MAX_SIZE_OF_ELEMENTS
    Public Const MJZ_ERR_BAD_CONDITIONS As UInteger = &HFFFFFFFCUL
    Public Const MJZ_ERR_INDETERMINATE As UInteger = &HFFFFFFFDUL
    Public Const MJZ_ERR_MEMORY As UInteger = &HFFFFFFFEUL
    Public Const MJZ_ERR_OVERFLOW As UInteger = &HFFFFFFFFUL


    Public Declare Function _
    mjzCompare Lib "mgc2jz.dll" _
    (ByVal Da() As UInteger, _
     ByVal Na As UInteger, _
     ByVal Db() As UInteger, _
     ByVal Nb As UInteger) As Integer

    Public Declare Function _
    mjzAdd Lib "mgc2jz.dll" _
    (ByVal Da() As UInteger, _
     ByVal Na As UInteger, _
     ByVal Db() As UInteger, _
     ByVal Nb As UInteger) As UInteger

    Public Declare Function _
    mjzCheckForFigures Lib "mgc2jz.dll" _
    (ByVal Da() As UInteger, ByVal Na As UInteger, ByVal figures As UInteger) As UInteger

    Public Declare Function _
    mjzCheckForZero Lib "mgc2jz.dll" _
    (ByVal Da() As UInteger, ByVal Na As UInteger) As UInteger

    Public Declare Function _
    mjzDivide Lib "mgc2jz.dll" _
    (ByVal Da() As UInteger, _
     ByVal Na As UInteger, _
     ByVal Db() As UInteger, _
     ByVal Nb As UInteger, _
     ByVal Dc() As UInteger, _
     ByVal Nc As UInteger) As UInteger

    Public Declare Function _
    mjzGetFigures Lib "mgc2jz.dll" _
    (ByVal Da() As UInteger, ByVal Na As UInteger) As UInteger

    Public Declare Function _
    mjzMultiply Lib "mgc2jz.dll" _
    (ByVal Da() As UInteger, _
     ByVal Na As UInteger, _
     ByVal Db() As UInteger, _
     ByVal Nb As UInteger, _
     ByVal Dc() As UInteger, _
     ByVal Nc As UInteger) As UInteger

    Public Declare Function _
    mjzPower Lib "mgc2jz.dll" _
    (ByVal powerBase() As UInteger, _
     ByVal Nb As UInteger, _
     ByVal power As Integer, _
     ByVal answer() As UInteger, _
     ByVal Na As UInteger) As UInteger

    Public Declare Function _
    mjzRemoveZero Lib "mgc2jz.dll" _
    (ByVal Da() As UInteger, ByVal nNa As UInteger) As UInteger

    Public Declare Function _
    mjzShiftToLeft Lib "mgc2jz.dll" _
    (ByVal Da() As UInteger, ByVal Na As UInteger, ByVal expression As UInteger) As UInteger

    Public Declare Function _
    mjzShiftToRight Lib "mgc2jz.dll" _
    (ByVal Da() As UInteger, ByVal Na As UInteger, ByVal expression As UInteger) As UInteger

    Public Declare Function _
    mjzGetFileVersion Lib "mgc2jz.dll" _
    (<MarshalAs(UnmanagedType.LPWStr)> ByVal file As String, _
     ByRef major As UInteger, _
     ByRef minor As UInteger, _
     ByRef revision As UInteger, _
     ByRef bild As UInteger) As Integer

End Module
