
// TestJZDlg.cpp : t@C
//
#include "stdafx.h"
#include "TestJZ.h"
#include "TestJZDlg.h"
#include "afxwin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CTestJZDlg _CAO
CTestJZDlg::CTestJZDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestJZDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestJZDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LABEL_A, m_labA);
	DDX_Control(pDX, IDC_LABEL_ANSWER, m_labAnswer);
	DDX_Control(pDX, IDC_LABEL_B, m_labB);
	DDX_Control(pDX, IDC_LABEL_CORRECT, m_labCorrect);
	DDX_Control(pDX, IDC_LABEL_ELAPSED_TIME, m_labElapsedTime);
	DDX_Control(pDX, IDC_LABEL_MARK, m_labMark);
	DDX_Control(pDX, IDC_LABEL_NUMBER, m_labNumber);
	DDX_Control(pDX, IDC_LABEL_REMAINDER, m_labRemainder);
	DDX_Control(pDX, IDC_LABEL_RESULT, m_labResult);
	DDX_Control(pDX, IDC_LABEL_VERSION, m_labVersion);
}

BEGIN_MESSAGE_MAP(CTestJZDlg, CDialog)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_ADD, &CTestJZDlg::OnBnClickedButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_DIVIDE, &CTestJZDlg::OnBnClickedButtonDivide)
	ON_BN_CLICKED(IDC_BUTTON_FACTORIAL, &CTestJZDlg::OnBnClickedButtonFactorial)
	ON_BN_CLICKED(IDC_BUTTON_FACTORIAL_OF_N, &CTestJZDlg::OnBnClickedButtonFactorialOfN)
	ON_BN_CLICKED(IDC_BUTTON_LOGARITHM, &CTestJZDlg::OnBnClickedButtonLogarithm)
	ON_BN_CLICKED(IDC_BUTTON_MULTIPLY, &CTestJZDlg::OnBnClickedButtonMultiply)
	ON_BN_CLICKED(IDC_BUTTON_POWER, &CTestJZDlg::OnBnClickedButtonPower)
	ON_BN_CLICKED(IDC_BUTTON_SQUARE_ROOT, &CTestJZDlg::OnBnClickedButtonSquareRoot)
	ON_BN_CLICKED(IDC_BUTTON_SUBTRACT, &CTestJZDlg::OnBnClickedButtonSubtract)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SYSCOMMAND()
END_MESSAGE_MAP()


// CTestJZDlg bZ[W nh

BOOL CTestJZDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	CString strVersion;
	DWORD dwMajor, dwMinor, dwRevision, dwBild;	

	if(m_jz.GetFileVersion(	_T("mgc2jz.dll"), 
							&dwMajor,
							&dwMinor, 
							&dwRevision,
							&dwBild	) == CM2jz::SUCCESS)
	{
		strVersion.Format(_T("JZ DLL VERSION %d.%d.%d.%d"), dwMajor, dwMinor, dwRevision, dwBild);
		m_labVersion.SetWindowText(strVersion);
	}

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CTestJZDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	CDialog::OnSysCommand(nID, lParam);
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CTestJZDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CTestJZDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTestJZDlg::OnBnClickedButtonAdd()
{
	// Z
	// EZ܂B
	// EQ 0xffff0000 - 0xffffffff ԂBIȂz̗vfB
	//   Ȃ킿z̍ővf 0xfffeffff łB
	// Ez̐擪͕\BPȂ}CiXAOȂvX
	// Eez̍ő包͂POiłXƂBȂ킿ő吔 999,999,999 łB
	static int nSwitch = 0;
	static int nMax = 5;

	BOOL  bCorrect;
	LONG  nStart;
	ULONG nFigures;
	ULONG nResult;
	

	EnableWindow(FALSE);
	nStart = clock(); 

	if(nSwitch == 0)
	{
		const ULONG nNa = 7;
		const ULONG nNb = 7;

		ULONG nDa[] = { CM2jz::NEGATIVE, 
					    CM2jz::RESERVED,
						0, 989797989, 756452854, 988974851, 250065987 };
		ULONG nDb[] = { CM2jz::NEGATIVE,
						CM2jz::RESERVED,
					    0, 999797989, 756452854, 988974851, 250065987 };
		ULONG nDc[nNa];
		ULONG nAc[] = { CM2jz::NEGATIVE,
						CM2jz::RESERVED,
					    1, 989595979, 512905709, 977949702, 500131974 };

		CopyMemory(nDc, nDa, sizeof(ULONG) * nNa);
		nResult  = m_jz.Add(nDc, nNa, nDb, nNb);
		bCorrect = m_jz.Compare(nDc, nResult, nAc, nResult) == 0;
		
		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nDc,
					nResult	 );
	}
	else if(nSwitch == 1)
	{
		const UINT nNa = 6;
		const UINT nNb = 4;

		ULONG nDa[] = { CM2jz::NEGATIVE, 
					    CM2jz::RESERVED,
						0, 999999999, 756452854, 988974851 }; 
		ULONG nDb[] = { CM2jz::NEGATIVE,
						CM2jz::RESERVED,
						999999999, 988974851 };
		ULONG nDc[nNa];
		ULONG nAc[] = { CM2jz::NEGATIVE,
						CM2jz::RESERVED,
					    1,         0, 756452854, 977949702 };
		
		CopyMemory(nDc, nDa, sizeof(ULONG) * nNa);
		nResult  = m_jz.Add(nDc, nNa, nDb, nNb);
		bCorrect = m_jz.Compare(nDc, nResult, nAc, nResult) == 0;
		
		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nDc,
					nResult	);
	}
	else if(nSwitch == 2)
	{
		const UINT nNa = 4;
		const UINT nNb = 6;

		ULONG nDa[] = { CM2jz::POSITIVE, 
						CM2jz::RESERVED,
					    999999999, 756452854 }; 
		ULONG nDb[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
						1, 999999999, 988974851, 0  };
		ULONG nDc[nNa];
		ULONG nAc[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
					    0,        0,         0 };
		
		CopyMemory(nDc, nDa, sizeof(ULONG) * nNa);
		nResult  = m_jz.Add(nDc, nNa, nDb, nNb);
		bCorrect = m_jz.Compare(nDc, nResult, nAc, nResult) == 0;
		
		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nDc,
					nResult );
	}
	else if(nSwitch == 3)
	{
		const UINT nNa = 6;
		const UINT nNb = 6;

		ULONG nDa[] = { CM2jz::POSITIVE, 
						CM2jz::RESERVED,
					    0,         0, 999999999, 756452854 }; 
		ULONG nDb[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
						1, 999999999, 988974851,         0 };
		ULONG nDc[nNa];
		ULONG nAc[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
					    2,         0, 988974850, 756452854 };
		
		CopyMemory(nDc, nDa, sizeof(ULONG) * nNa);
		nResult  = m_jz.Add(nDc, nNa, nDb, nNb);
		bCorrect = m_jz.Compare(nDc, nResult, nAc, nResult) == 0;
		
		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nDc,
					nResult );
	}
	else if(nSwitch == 4)
	{
		const ULONG nNa = 25;
		const ULONG nNb = 20;
		
		ULONG nDa[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
						528549889, 748512565, 987458245, 628598789, 897979897, 564528549, 
						889748512, 500659528, 549889748, 512565987, 458245628, 598789897,
						979897564, 528549889, 748512500, 659528549, 889748512, 565987458, 
						245628598, 789897979, 897564528, 549889748, 512500659	};
		ULONG nDb[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
						      989, 797989756, 452854988, 974851250,  65987458, 245628598,
						789898979, 798975645, 285498897, 485125006, 598745824, 562859878,
						989897979, 897564528, 549889748, 512500659, 874582456, 285987898 };
		ULONG nDc[nNa];
		// answer
		ULONG nAc[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
						528549889, 748512565, 987458245, 628598789, 897979897, 564529539,
						687738268, 953514517, 524740998, 578553445, 703874227, 388688877,
						778873209, 814048787, 233637507, 258274374, 452608391, 555885438,
						143193127, 339787728, 410065188, 424472204, 798488557 };

		CopyMemory(nDc, nDa, sizeof(ULONG) * nNa);
	
		// wl菬ffBׂĐΔz̍ővfԂB
		nFigures = m_jz.CheckForFigures(nDc, nNa, 9);
		nResult  = m_jz.Add(nDc, nNa, nDb, nNb);
		// ӂ̔zlł邱ƂffBׂĐ TRUE ԂB
		bCorrect = m_jz.Compare(nDc, nNa, nAc, nNa) == 0;

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nDc,
					nResult );
	}

	if(++nSwitch == nMax)
		nSwitch = 0;

	EnableWindow(TRUE);
}

void CTestJZDlg::OnBnClickedButtonDivide()
{
	// Z
	// EZ܂B
	// EQ 0xffff0000 - 0xffffffff ԂBIȂz̗vfB
	//   Ȃ킿z̍ővf 0xfffeffff łB
	// Ez̐擪͕\BPȂ}CiXAOȂvX
	// EƔ폜̔z̗vf͈قȂĂ\Ȃ
	// Eez̍ő包͂POiłXƂBȂ킿ő吔 999,999,999 łB
	// ETAP]ƂȂ
	static const int nMax = 8;
	static const int nNc  = 8; 
	static int nSwitch = 0;
		
	BOOL  bCorrect;
	ULONG nResult;
	LONG  nStart;

	EnableWindow(FALSE);
	nStart = clock();  

	if(nSwitch == 0)
	{
		const ULONG nNa = 6;
		const ULONG nNb = 3;
		const ULONG nNq = 6;
		ULONG nDa[] = { CM2jz::POSITIVE,  
						CM2jz::RESERVED,
						5, 0, 0, 0 };
		ULONG nDb[] = { CM2jz::POSITIVE,   
						CM2jz::RESERVED,
 						220000000 };
		ULONG nAc[] = { CM2jz::POSITIVE,	
						CM2jz::RESERVED,
						0, 22, 727272727, 272727272 };
		ULONG nQuotient[nNq];
		ULONG nRemainder[nNa];	// Remainder = 160000000

		CopyMemory(nRemainder, nDa, sizeof(nDa));
	
		nResult = m_jz.Divide(nRemainder, nNa, nDb, nNb, nQuotient, nNq);
		bCorrect = m_jz.Compare(nQuotient, nNq, nAc, nNq) == 0;

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nQuotient,
					nResult,
					nRemainder, 
					nNa );
	}
	else if(nSwitch == 1)
	{
		const ULONG nNa = 4;
		const ULONG nNb = 4;
		const ULONG nNq = 5;
		ULONG nDa[] = { CM2jz::NEGATIVE,  
						CM2jz::RESERVED,
						100,         0 };
		ULONG nDb[] = { CM2jz::POSITIVE,   
						CM2jz::RESERVED,
 						  9,         0 };
		ULONG nAc[] = { CM2jz::NEGATIVE,	
						CM2jz::RESERVED,
						  0,         0,       11 };
		ULONG nQuotient[nNq];
		ULONG nRemainder[nNa];	// Remainder = -1,000000000

		CopyMemory(nRemainder, nDa, sizeof(nDa));
	
		nResult = m_jz.Divide(nRemainder, nNa, nDb, nNb, nQuotient, nNq);
		bCorrect = m_jz.Compare(nQuotient, nNq, nAc, nNq) == 0;

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nQuotient,
					nResult,
					nRemainder, 
					nNa );
	}
	else if(nSwitch == 2)
	{
		const ULONG nNa = 5;
		const ULONG nNb = 4;
		const ULONG nNq = 6;
		ULONG nDa[] = { CM2jz::POSITIVE,  
						CM2jz::RESERVED,
						100000000,         0,         0 };
		ULONG nDb[] = { CM2jz::POSITIVE,   
						CM2jz::RESERVED,
 						  1000000,         0 };
		ULONG nAc[] = { CM2jz::POSITIVE,	
						CM2jz::RESERVED,
						        0,         0,       100,         0 };
		ULONG nQuotient[nNq];
		ULONG nRemainder[nNa];	// Remainder = 0

		CopyMemory(nRemainder, nDa, sizeof(nDa));
	
		nResult = m_jz.Divide(nRemainder, nNa, nDb, nNb, nQuotient, nNq);
		bCorrect = m_jz.Compare(nQuotient, nNq, nAc, nNq) == 0;

		SetLabels(	nSwitch,
					bCorrect, 
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nQuotient,
					nResult,
					nRemainder, 
					nNa	);
	}
	else if(nSwitch == 3)
	{
		const ULONG nNa = 5;
		const ULONG nNb = 4;
		const ULONG nNq = 5;
		ULONG nDa[] = { CM2jz::NEGATIVE,  
						CM2jz::RESERVED,
						100000000,         0,         0 };
		ULONG nDb[] = { CM2jz::NEGATIVE,   
						CM2jz::RESERVED,
 						  3000000,         0 };
		ULONG nAc[] = { CM2jz::POSITIVE,	
						CM2jz::RESERVED,
						        0,        33, 333333333 };
		ULONG nQuotient[nNq];
		ULONG nRemainder[nNa];	// Remainder = -1000000,000000000

		CopyMemory(nRemainder, nDa, sizeof(nDa));
	
		nResult = m_jz.Divide(nRemainder, nNa, nDb, nNb, nQuotient, nNq);
		bCorrect = m_jz.Compare(nQuotient, nNq, nAc, nNq) == 0;

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nQuotient,
					nResult,
					nRemainder, 
					nNa	);
	}
	else if(nSwitch == 4)
	{
		const ULONG nNa = 4;
		const ULONG nNb = 4;
		const ULONG nNq = 5;
		ULONG nDa[] = { CM2jz::POSITIVE,  
						CM2jz::RESERVED,
						428224, 593349304 };
		ULONG nDb[] = { CM2jz::NEGATIVE,   
						CM2jz::RESERVED,
						     1, 121570117 };
		ULONG nAc[] = { CM2jz::NEGATIVE,	
						CM2jz::RESERVED,
						     0,         0,    381808 };
		ULONG nQuotient[nNq];
		ULONG nRemainder[nNa];	// Remainder = 150117768

		CopyMemory(nRemainder, nDa, sizeof(nDa));
	
		nResult = m_jz.Divide(nRemainder, nNa, nDb, nNb, nQuotient, nNq);
		bCorrect = m_jz.Compare(nQuotient, nNq, nAc, nNq) == 0;

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nQuotient,
					nResult,
					nRemainder, 
					nNa	);
	}
	else if(nSwitch == 5)
	{
		const ULONG nNa = 5;
		const ULONG nNb = 4;
		const ULONG nNq = 9;
		ULONG nDa[] = { CM2jz::NEGATIVE,  
						CM2jz::RESERVED,
						        5,         0,         0 };
		ULONG nDb[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
						        4, 555555555 }; 
		ULONG nAc[] = { CM2jz::NEGATIVE,	
						CM2jz::RESERVED,
						        0,         0,         0,         0,         0,         1, 
						 97560975 };
		ULONG nQuotient[nNq];
		ULONG nRemainder[nNa];	// nRemainder = -3,387533875
		

		CopyMemory(nRemainder, nDa, sizeof(nDa));
	
		nResult = m_jz.Divide(nRemainder, nNa, nDb, nNb, nQuotient, nNq);
		bCorrect = m_jz.Compare(nQuotient, nNq, nAc, nNq) == 0;

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nQuotient,
					nResult,
					nRemainder, 
					nNa	);
	}
	else if(nSwitch == 6)
	{
		const ULONG nNa = 9;
		const ULONG nNb = 4;
		const ULONG nNq = 9;
		ULONG nDa[] = { CM2jz::POSITIVE,  
						CM2jz::RESERVED,
					       428224, 593349304,         0,         0,         0,        0,
						        0 };
		ULONG nDb[] = { CM2jz::POSITIVE,   
						CM2jz::RESERVED,
						   136308, 121570117 };
		ULONG nAc[] = { CM2jz::POSITIVE, 
						CM2jz::RESERVED,
						        0,         3, 141592653, 589793238, 462643383,
						275697434, 469140732 };
		ULONG nQuotient[nNq];
		ULONG nRemainder[nNa];	// Remainder = 89272, 321294356
		// PI = 3
		//      141592653
		//      589793238
		//      462643383
		//      279502884
		//      197169399
		CopyMemory(nRemainder, nDa, sizeof(nDa));
	
		nResult = m_jz.Divide(nRemainder, nNa, nDb, nNb, nQuotient, nNq);
		bCorrect = m_jz.Compare(nQuotient, nNq, nAc, nNq) == 0;

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nQuotient,
					nResult,
					nRemainder, 
					nNa	);
	}
	else if(nSwitch == 7)
	{
		const ULONG nNa = 12;
		const ULONG nNb = 5;
		const ULONG nNq = 12;
		ULONG nDa[] = { CM2jz::POSITIVE,  
						CM2jz::RESERVED,
						763240896, 824487567, 620000000, 0, 0, 0, 0, 0, 0, 0 };
		ULONG nDb[] = { CM2jz::POSITIVE,   
						CM2jz::RESERVED,
						242947122, 999016956, 630000000  };

		ULONG nAc[] = { CM2jz::POSITIVE, 
						CM2jz::RESERVED,
						        0,         0,         3, 141592653, 589793238, 462643383,
						279502884, 134204314, 768296341, 347735847	};
		ULONG nQuotient[nNq];
		ULONG nRemainder[nNa];	

		// PI = 3
		//      141592653	
		//      589793238
		//      462643383
		//      279502884
		//      197169399
		CopyMemory(nRemainder, nDa, sizeof(nDa));
	
		nResult = m_jz.Divide(nRemainder, nNa, nDb, nNb, nQuotient, nNq);
		bCorrect = m_jz.Compare(nQuotient, nNq, nAc, nNq) == 0;

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nDa,
					nNa,
					nDb,
					nNb,
					nQuotient,
					nResult,
					nRemainder, 
					nNa	);
	}

	if(++nSwitch == nMax)
		nSwitch = 0;

	EnableWindow(TRUE);
}

void CTestJZDlg::OnBnClickedButtonFactorial()
{
	// ǨvZ
	// EX^[Őߎ@n! = n^n * e^-n * (2*n*pi)^(1/2)
	static const int nMax = 2;
	static int nSwitch = 0;
		
	BOOL  bCorrect;
	ULONG nResult;
	LONG  nStart;

	EnableWindow(FALSE);
	nStart = clock();  

	if(nSwitch == 0)
	{
		const LONG nN = 70;
		const ULONG nNac = 14;

		ULONG lpDa[] = { CM2jz::POSITIVE, 
						 CM2jz::RESERVED,
						 nN	};
		ULONG *lpDb, *lpDd, *lpDt;
		ULONG lpC[] = {	CM2jz::POSITIVE, 
						CM2jz::RESERVED,
						2	};
		ULONG nAc[] = { CM2jz::POSITIVE, 
						CM2jz::RESERVED,
						       11, 978571669, 969891796,  72783721, 689098736, 458938142,
						546425857, 555362864, 628009582, 789845319, 680000000, 000000000 };
		ULONG nFigures;
		ULONG nSize;


		// X^[Őߎ茅Ƃ߂
		nFigures = (ULONG)(nN * log10(nN * 0.3678794411714) + 0.5 * log10(2.0 * M_PI) + 1);
		nSize = nFigures / CM2jz::SIGNIFICANT_FIGURES + 1 + CM2jz::NUMERICAL_POINTER;

		lpDb = new ULONG[nSize];
		lpDd = new ULONG[nSize];
		SecureZeroMemory(lpDb, nSize * sizeof(ULONG));
		SecureZeroMemory(lpDd, nSize * sizeof(ULONG));

		lpDb[nSize - 1] = 1;

		for(ULONG nI = 0; nI < nN; nI++)
		{
			nResult = m_jz.Multiply(lpDb, nSize, lpC, 3, lpDd, nSize);

			lpDt = lpDd;
			lpDd = lpDb;
			lpDb = lpDt;

			lpC[CM2jz::NUMERICAL_POINTER] ++;
		}

		bCorrect = m_jz.Compare(lpDd, nResult, nAc, nNac) == 0;
		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					lpDa, 
					3,
					NULL,
					1,
					lpDd,
					nResult	);

		delete [] lpDb;
		delete [] lpDd;
	}
	else if(nSwitch == 1)
	{
		const LONG nN = 180;
		const ULONG nNac = 39;

		ULONG lpDa[] = { CM2jz::POSITIVE, 
						 CM2jz::RESERVED,
						 nN	};
		ULONG *lpDb, *lpDd, *lpDt;
		ULONG lpC[] = {	CM2jz::POSITIVE, 
						CM2jz::RESERVED,
						2	};
		ULONG nAc[] = { CM2jz::POSITIVE, 
						CM2jz::RESERVED,
						   200896,  62499134, 299656951, 336898466, 838917540, 340798867, 
						777940435, 335160044, 860953395, 980941180, 138112097, 309735631,
						594101037, 399609671,  32132186, 331495273, 609598531, 966730972,
						945653558, 819806475,  64353856, 858157445,  40809209, 560358463,
						319644664, 891114256, 430017824, 141796753, 818192338, 642302693,
						327818731, 986039603, 200000000,         0,         0,         0,
						0 };
		ULONG nFigures;
		ULONG nSize;


		// ̗\z
		// X^[Őߎ
		nFigures = (ULONG)(nN * log10(nN * 0.3678794411714) + 0.5 * log10(2.0 * M_PI) + 1);
		nSize = nFigures / CM2jz::SIGNIFICANT_FIGURES + 1 + CM2jz::NUMERICAL_POINTER;

		lpDb = new ULONG[nSize];
		lpDd = new ULONG[nSize];
		SecureZeroMemory(lpDb, nSize * sizeof(ULONG));
		SecureZeroMemory(lpDd, nSize * sizeof(ULONG));

		lpDb[nSize - 1] = 1;

		for(ULONG nI = 0; nI < nN; nI++)
		{
			nResult = m_jz.Multiply(lpDb, nSize, lpC, 3, lpDd, nSize);
			
			lpDt = lpDd;
			lpDd = lpDb;
			lpDb = lpDt;

			lpC[CM2jz::NUMERICAL_POINTER] ++;
		}

		bCorrect = m_jz.Compare(lpDd, nResult, nAc, nNac) == 0;
		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					lpDa, 
					3,
					NULL,
					1,
					lpDd,
					nResult	);

		delete [] lpDb;
		delete [] lpDd;
	}

	if(++nSwitch == nMax)
		nSwitch = 0;

	EnableWindow(TRUE);
}

void CTestJZDlg::OnBnClickedButtonFactorialOfN()
{
#if _DEBUG	
	const LONG nN		 = 100000;
	const ULONG nDivisor = 1000;
#else
	const LONG nN		 = 100000;
	const ULONG nDivisor = 1000;
#endif
	const ULONG nNac = 14;

	LONG  nA;
	LONG  nStart;
	ULONG nResult;
	ULONG nFigures;
	ULONG nSize;

	ULONG lpDa[] = { CM2jz::POSITIVE, 
					 CM2jz::RESERVED,
					 nN	};
	ULONG *lpDb, *lpDd, *lpDt;
	ULONG lpC[] = {	CM2jz::POSITIVE, 
					CM2jz::RESERVED,
					2	};
	

	EnableWindow(FALSE);
	nStart = clock();  
	SetLabels();

	// X^[Őߎ茅Ƃ߂
	nFigures = (ULONG)(nN * log10(nN * 0.3678794411714) + 0.5 * log10(2.0 * M_PI) + 1);
	nSize = nFigures / CM2jz::SIGNIFICANT_FIGURES + 1 + CM2jz::NUMERICAL_POINTER;

	lpDb = new ULONG[nSize];
	lpDd = new ULONG[nSize];
	SecureZeroMemory(lpDb, nSize * sizeof(ULONG));
	SecureZeroMemory(lpDd, nSize * sizeof(ULONG));

	lpDb[nSize - 1] = 1;
	nA = 0;

	for(ULONG nI = 0; nI < nN; nI++)
	{
		nResult = m_jz.Multiply(lpDb, nSize, lpC, 3, lpDd, nSize);

		lpDt = lpDd;
		lpDd = lpDb;
		lpDb = lpDt;

		lpC[CM2jz::NUMERICAL_POINTER] ++;

		if(lpC[CM2jz::NUMERICAL_POINTER] % nDivisor == 0)
			SetLabel(++nA);
	}

	SetLabel(nA = 0);

	// t@C֏o
	CString strOutput;
	CString strTmp;
	FILE	*lpFile;
	TCHAR	szFileName[MAX_PATH];
	TCHAR	szFilePath[MAX_PATH];
	ULONG	nPointer;

	
	wsprintf(szFileName, _T("Factorial of %d.txt"), nN);
	
	if(_tfopen_s(&lpFile, szFileName, _T("wt, ccs=UTF-8")) == 0)
	{
		nPointer = CM2jz::NUMERICAL_POINTER;

		strOutput.Format(_T("%d ! =\n"), nN);
		fwrite(strOutput.GetBuffer(), sizeof(TCHAR), strOutput.GetLength(), lpFile);

		for( ; ; )
		{
			strOutput = "";

			for(ULONG nJ = 0; nJ < 9; nJ++)
			{
				strTmp.Format(_T("%09d "), lpDd[nPointer]);
				strOutput += strTmp;
				nPointer++;

				if(nPointer >= nSize)
					break;
			}
			
			fwrite(strOutput.GetBuffer(), sizeof(TCHAR), strOutput.GetLength(), lpFile);
			fwrite(_T("\n"), sizeof(TCHAR), 1, lpFile);

			if(nPointer >= nSize)
				break;
		}

		_tfullpath(szFilePath, szFileName, MAX_PATH);
		strOutput.Format(_T("The file was made.\n\n%s"), szFilePath);
		AfxMessageBox(strOutput.GetBuffer(), MB_OK|MB_ICONINFORMATION);   

		fclose(lpFile);
	}

	delete [] lpDb;
	delete [] lpDd;

	SetLabels(nStart, clock(), lpDa, 3);

	EnableWindow(TRUE);
}

void CTestJZDlg::OnBnClickedButtonLogarithm()
{
	// ΐ
	// ElogX = 1/X ̖ʐ
	// Eϕɑ`gp logX = h/2 * (1/1+1/Xn+2*(1/X1+1/X2....1/Xn-1))
	static const int nMax = 1;
	static int nSwitch = 0;
	
	ULONG nResult;
	LONG  nStart;


	EnableWindow(FALSE);
	SetLabels();
	nStart = clock();

	// log3.1 = 1.131402111491100561911172869858
	const ULONG nN  = 12; 
	const ULONG nNf = 5; 
	const ULONG nNh = 5; 
	const ULONG nNi = 3; 
	const ULONG nNs = 24; 
	
	ULONG nF0[] = { CM2jz::POSITIVE,
					CM2jz::RESERVED,
					0, 1, 0, 0, 0, 0, 0, 0, 0, 0 };
	ULONG nFn[] = { CM2jz::POSITIVE,
					CM2jz::RESERVED,
					0, 3, 100000000 };
#if _DEBUG
	ULONG nH[]  = { CM2jz::POSITIVE,
					CM2jz::RESERVED,
					0, 0, 2100000 };
#else
	ULONG nH[]  = { CM2jz::POSITIVE,
					CM2jz::RESERVED,
					0, 0, 21000 };
#endif
	ULONG nS[nNs];
	ULONG nS0[nN], nS1[nN], nS2[nN], nSn[nN];
	ULONG nTa[nN], nTb[nN], nTc[nN];
	ULONG nI[nNi];
	INT	  nA;
	ULONG nLimit, nDivisor;

	nA = 0;
#if _DEBUG
	nLimit	 = 1000;
	nDivisor = 250;
#else
	nLimit	 = 100000;
	nDivisor = 10000;
#endif
	SecureZeroMemory(nS, sizeof(nS));
	SecureZeroMemory(nS0, sizeof(nS0));
	SecureZeroMemory(nS1, sizeof(nS1));
	SecureZeroMemory(nS2, sizeof(nS2));
	SecureZeroMemory(nSn, sizeof(nSn));
	SecureZeroMemory(nTa, sizeof(nTa));
	SecureZeroMemory(nTb, sizeof(nTb));
	SecureZeroMemory(nTc, sizeof(nTc));
	SecureZeroMemory(nI, sizeof(nI));

	nTa[CM2jz::NUMERICAL_POINTER] = 1;
	nResult = m_jz.Divide(nTa, nN, nFn, nNf, nS0, nN);
	nResult = m_jz.Add(nS0, nN, nF0, nN);

	nTb[CM2jz::NUMERICAL_POINTER + 1] = 1;

	for( nI[CM2jz::NUMERICAL_POINTER] = 1; 
		 nI[CM2jz::NUMERICAL_POINTER] < nLimit;
		 nI[CM2jz::NUMERICAL_POINTER]++ )
	{
		SecureZeroMemory(nTa, sizeof(nTa));
		SecureZeroMemory(nTc, sizeof(nTc));
		nTc[CM2jz::NUMERICAL_POINTER] = 1;

		nResult = m_jz.Multiply(nI, nNi, nH, nNh, nTa, 5);
		nResult = m_jz.Add(nTa, nResult, nTb, nResult);
		nResult = m_jz.Divide(nTc, nN, nTa, nResult, nSn, nN);
		nResult = m_jz.Add(nS1, nN, nSn, nN);

		if(nI[CM2jz::NUMERICAL_POINTER] % nDivisor == 0)
			SetLabel(++nA);
	}

	SetLabel(nA = 0);

	SecureZeroMemory(nTa, sizeof(nTa));
	SecureZeroMemory(nTb, sizeof(nTb));
	nTa[nN - 1] = 2; 
	nResult = m_jz.Multiply(nS1, nN, nTa, nN, nS2, nN);
	nResult = m_jz.Add(nS2, nN, nS0, nN);
	nTa[CM2jz::NUMERICAL_POINTER] = 2; 
	nResult = m_jz.Divide(nH, nNh, nTa, 3, nTb, nNh);
	nResult = m_jz.Multiply(nS2, nN, nTb, nResult, nS, nN + 1);

	SetLabels(nSwitch, TRUE, nStart, clock(), nFn, nNf, NULL, 0, nS, nResult);


	if(++nSwitch == nMax)
		nSwitch = 0;

	EnableWindow(TRUE);
}

void CTestJZDlg::OnBnClickedButtonMultiply()
{
	// Z
	// EZ܂B
	// EQ 0xffff0000 - 0xffffffff ԂBIȂz̗vfB
	//   Ȃ킿z̍ővf 0xfffeffff łB
	// Ez̍Ō͕\BPȂ}CiXAOȂvX
	// E搔Ɣ搔̔z̗vf͈قȂĂ\Ȃ
	// Eez̍ő包͂POiłXƂBȂ킿ő吔 999,999,999 łB
	static const int nMax = 4;
	static int nSwitch = 0;
	
	BOOL  bCorrect;
	ULONG nFigures;
	ULONG nResult;
	LONG  nStart;


	EnableWindow(FALSE);
	nStart = clock();

	if(nSwitch == 0)
	{
		const ULONG nNa = 3;
		const ULONG nNb = 6;
		const ULONG nNc = nNa + nNb;
		ULONG nDa[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
						22 };
		ULONG nDb[] = { CM2jz::NEGATIVE,
						CM2jz::RESERVED,
						5, 0, 0, 0 };
		ULONG nDc[nNc];
		ULONG nAc[] = { CM2jz::NEGATIVE,
						CM2jz::RESERVED,
						110, 000000000, 000000000, 000000000 };

		nResult  = m_jz.Multiply(nDa, nNa, nDb, nNb, nDc, nNc);
		nResult = m_jz.CheckForZero(nDc, nNc);
		nResult = m_jz.ShiftToLeft(nDc, nNc, nResult - CM2jz::NUMERICAL_POINTER);

		bCorrect = m_jz.Compare(nDc, nResult, nAc, nResult) == 0;

		SetLabels(nSwitch, bCorrect, nStart, clock(), nDa, nNa, nDb, nNb, nDc, nResult);
	}
	else if(nSwitch == 1)
	{
		const ULONG nNa = 6;
		const ULONG nNb = 4;
		const ULONG nNc = nNa + nNb;
		ULONG nDa[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
						0, 999999999, 3, 4 };
		ULONG nDb[] = { CM2jz::NEGATIVE,
						CM2jz::RESERVED,
						0, 2 };
		ULONG nDc[nNc];
		ULONG nAc[] = { CM2jz::NEGATIVE,
						CM2jz::RESERVED,
						1, 999999998, 6, 8 };

		nResult  = m_jz.Multiply(nDa, nNa, nDb, nNb, nDc, nNc);
		nResult = m_jz.CheckForZero(nDc, nNc);
		nResult = m_jz.ShiftToLeft(nDc, nNc, nResult - CM2jz::NUMERICAL_POINTER);

		bCorrect = m_jz.Compare(nDc, nResult, nAc, nResult) == 0;

		SetLabels(nSwitch, bCorrect, nStart, clock(), nDa, nNa, nDb, nNb, nDc, nResult);
	}
	else if(nSwitch == 2)
	{
		const ULONG nNa = 7;
		const ULONG nNb = 6;
		const ULONG nNc = nNa + nNb;
		ULONG nDa[] = { CM2jz::NEGATIVE,  
						CM2jz::RESERVED,
					        28903, 488454507, 298383837, 123456789, 999999999 };
		ULONG nDb[] = { CM2jz::NEGATIVE,   
						CM2jz::RESERVED,
 					         4578, 936777772, 356789900, 999999999 };
		ULONG nDc[nNc];
		ULONG nAc[] = { CM2jz::POSITIVE,	
						CM2jz::RESERVED,
					    132347246, 290262165, 544328339, 628472603, 893291066,
						646716180, 519753309, 000000001	};

		nResult  = m_jz.Multiply(nDa, nNa, nDb, nNb, nDc, nNc);
		nResult = m_jz.CheckForZero(nDc, nNc);
		nResult = m_jz.ShiftToLeft(nDc, nNc, nResult - CM2jz::NUMERICAL_POINTER);

		bCorrect = m_jz.Compare(nDc, nResult, nAc, nResult) == 0;

		SetLabels(nSwitch, bCorrect, nStart, clock(), nDa, nNa, nDb, nNb, nDc, nResult);
	}
	else if(nSwitch == 3)
	{
		const ULONG nNa = 12;
		const ULONG nNb = 4;
		const ULONG nNc = nNa + nNb;
		ULONG nDa[] = { CM2jz::POSITIVE,	
						CM2jz::RESERVED,
					    123456787, 654345678,  98764321,       654, 321876543, 210099987,
					    654328890, 346543219, 876547820, 987654321 };
		ULONG nDb[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
					            7, 
					    582918690 };
		ULONG nDc[nNc];
		ULONG nAc[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
						936162782, 511499102, 175843635, 616064451, 669586915, 380459793,
						152779802,  15763158, 894653964, 446058209, 970159490 };

		nFigures = m_jz.CheckForFigures(nDa, nNa, 9);
		nFigures = m_jz.CheckForFigures(nDb, nNb, 9);
		nResult  = m_jz.Multiply(nDa, nNa, nDb, nNb, nDc, nNc);
		nResult = m_jz.CheckForZero(nDc, nNc);
		nResult = m_jz.ShiftToLeft(nDc, nNc, nResult - CM2jz::NUMERICAL_POINTER);

		bCorrect = m_jz.Compare(nDc, nResult, nAc, nResult) == 0;

		SetLabels(nSwitch, bCorrect, nStart, clock(), nDa, nNa, nDb, nNb, nDc, nResult);
	}

	if(++nSwitch == nMax)
		nSwitch = 0;

	EnableWindow(TRUE);
}


void CTestJZDlg::OnBnClickedButtonPower()
{
	// ׂ
	static const int nMax = 2;
	static int nSwitch = 0;

	LONG nStart;


	EnableWindow(FALSE);
	nStart = clock();
	
	if(nSwitch == 0)
	{
		const int nNa	= 8;
		ULONG  nPower	= 19;
		ULONG nAnswer[nNa];
		ULONG nBase[]	= { CM2jz::POSITIVE,
							CM2jz::RESERVED, 10 };
		ULONG nP[]		= { CM2jz::POSITIVE,
							CM2jz::RESERVED, nPower };
		ULONG nAc[]		= { CM2jz::POSITIVE,
							CM2jz::RESERVED,
							10, 000000000, 000000000 };
	
		BOOL  bCorrect = FALSE;
		ULONG nResult;
		
	
		nResult = m_jz.Power(nBase, 3, nPower, nAnswer, nNa);

		if(nResult < CM2jz::MAX_SIZE_OF_ELEMENTS)
		{
			nResult = m_jz.ShiftToLeft(	nAnswer, 
									nNa,
									m_jz.CheckForZero(nAnswer, nNa) - CM2jz::NUMERICAL_POINTER);
			bCorrect = m_jz.Compare(nAnswer, nResult, nAc, nResult) == 0;
		}

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nBase, 
					3,
					nP,
					3,
					nAnswer,
					nResult	);
	}
	if(nSwitch == 1)
	{
		const int nNa	= 32;
		ULONG  nPower	= 102;
		ULONG nAnswer[nNa];
		ULONG nBase[]	= { CM2jz::POSITIVE,
							CM2jz::RESERVED, 39 };
		ULONG nP[]		= { CM2jz::POSITIVE,
							CM2jz::RESERVED, nPower };
		ULONG nAc[]		= { CM2jz::POSITIVE,
							CM2jz::RESERVED,
							        1, 943524039,  63826536, 649857299, 724357504, 709860298, 
							384642872, 517237682, 989751006, 104182243, 343398736, 298811722, 
							231536565, 749131513,  96597373, 810943242, 880339240, 987952031,
							963437521 };
	
		BOOL  bCorrect = FALSE;
		ULONG nResult;
		
	
		nResult = m_jz.Power(nBase, 3, nPower, nAnswer, nNa);

		if(nResult < CM2jz::MAX_SIZE_OF_ELEMENTS)
		{
			nResult = m_jz.ShiftToLeft(	nAnswer,
									nNa,
									m_jz.CheckForZero(nAnswer, nNa) - CM2jz::NUMERICAL_POINTER);
			bCorrect = m_jz.Compare(nAnswer, nResult, nAc, nResult) == 0;
		}

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nBase, 
					3,
					nP,
					3,
					nAnswer,
					nResult	);
	}

	if(++nSwitch == nMax)
		nSwitch = 0;

	EnableWindow(TRUE);
}

void CTestJZDlg::OnBnClickedButtonSquareRoot()
{
	//  
	//	E߂
	//	Ej[g@gp
	//	Ey = x^2 - a  0 = (x + a / x) / 2 Zo 
	static const int nMax = 2;
	static int nSwitch = 0;

	const ULONG nN	 = 12;
	const ULONG nNe  = 24;
	const ULONG nN2	 = 3;
	const ULONG nNac = 6;

	BOOL  bCorrect;
	LONG  nStart;
	LONG  nSize;	
	ULONG nDa[nN];
	ULONG nDc[nN];
	ULONG nDq[nN];
	ULONG nDe[nNe];
	ULONG nResult;


	EnableWindow(FALSE);
	nStart = clock();

	if(nSwitch == 0)
	{
		// square root of 7
		ULONG nInitialValue[] = { 2, 500000000 };
		ULONG nTarget[]		  = { CM2jz::POSITIVE,	
								  CM2jz::RESERVED,
								  7, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
		ULONG nAc[]			  = { CM2jz::POSITIVE,
								  CM2jz::RESERVED,
								  2, 645751311,  64590590, 501615753, 6393 };
		ULONG nErrorRange[]	  = { CM2jz::POSITIVE,	
							      CM2jz::RESERVED,
								          0,         0,         0,         0,         0, 999999999, 
								  999999999, 999999999, 999999999, 999999999 };
		ULONG nD2[nN2] = {	CM2jz::POSITIVE,	
							CM2jz::RESERVED,
							2 };
		
		nSize = nN * sizeof(ULONG);
		SecureZeroMemory(nDc, nSize);
		CopyMemory(&nDc[7], nInitialValue, sizeof(nInitialValue));

		for(ULONG nI = 0; nI < 10; nI++)
		{
			CopyMemory(nDa, nTarget, nSize);
		
			nResult = m_jz.Divide(nDa, nN, nDc, nN, nDq, nN);
			nResult = m_jz.RemoveZero(nDq, nN);
			CopyMemory(nDa, nDc, nSize);
			nResult = m_jz.RemoveZero(nDa, nN);
			nResult = m_jz.Add(nDq, nN, nDa, nN);
			nResult = m_jz.Divide(nDq, nN, nD2, nN2, nDc, nN);

			// 
			nResult  = m_jz.Multiply(nDc, nN, nDc, nN, nDe, nNe);
			nDe[CM2jz::SIGN_POINTER] = CM2jz::NEGATIVE;
			nResult = m_jz.RemoveZero(nDe, nNe);
			nResult = m_jz.Add(nDe, nN, nTarget, nN);
			nDe[CM2jz::SIGN_POINTER] = CM2jz::POSITIVE;

			if(m_jz.Compare(nDe, nN, nErrorRange, nN) < 0)
				break;

			nResult  = m_jz.ShiftToRight(nDc, nN, 4);
		}

		nResult = m_jz.RemoveZero(nDc, nN);
		bCorrect = m_jz.Compare(nDc, nNac, nAc, nNac) == 0;

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nTarget, 
					nN,
					NULL,
					1,
					nDc,
					nN	);
	}
	else if(nSwitch == 1)
	{
		// square root of 99
		ULONG nInitialValue[] = { 9, 000000000 };
		ULONG nTarget[]		  = { CM2jz::POSITIVE,	
							   	  CM2jz::RESERVED,
								  99, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
		ULONG nAc[]			  = { CM2jz::POSITIVE,
							  	  CM2jz::RESERVED,
								  9, 949874371, 66199547, 344798210, 121 };
		ULONG nErrorRange[]	  = { CM2jz::POSITIVE,	
							  	  CM2jz::RESERVED,
								          0,         0,         0,         0,         0, 999999999, 
								  999999999, 999999999, 999999999, 999999999 };
		ULONG nD2[nN2] = {	CM2jz::POSITIVE,	
							CM2jz::RESERVED,
							2 };

		nSize = nN * sizeof(ULONG);
		SecureZeroMemory(nDc, nSize);
		CopyMemory(&nDc[7], nInitialValue, sizeof(nInitialValue));

		for(ULONG nI = 0; nI < 10; nI++)
		{
			CopyMemory(nDa, nTarget, nSize);
		
			nResult = m_jz.Divide(nDa, nN, nDc, nN, nDq, nN);
			nResult = m_jz.RemoveZero(nDq, nN);
			CopyMemory(nDa, nDc, nSize);
			nResult = m_jz.RemoveZero(nDa, nN);
			nResult = m_jz.Add(nDq, nN, nDa, nN);
			nResult = m_jz.Divide(nDq, nN, nD2, nN2, nDc, nN);

			// 
			nResult  = m_jz.Multiply(nDc, nN, nDc, nN, nDe, nNe);
			nDe[CM2jz::SIGN_POINTER] = CM2jz::NEGATIVE;
			nResult = m_jz.RemoveZero(nDe, nNe);
			nResult = m_jz.Add(nDe, nN, nTarget, nN);
			nDe[CM2jz::SIGN_POINTER] = CM2jz::POSITIVE;

			if(m_jz.Compare(nDe, nN, nErrorRange, nN) < 0)
				break;

			nResult = m_jz.ShiftToRight(nDc, nN, 4);
		}

		nResult = m_jz.RemoveZero(nDc, nN);
		bCorrect = m_jz.Compare(nDc, nNac, nAc, nNac) == 0;

		SetLabels(	nSwitch,
					bCorrect,
					nStart,
					clock(),
					nTarget, 
					nN,
					NULL,
					1,
					nDc,
					nN	);
	}
	
	if(++nSwitch == nMax)
		nSwitch = 0;

	EnableWindow(TRUE);
}

void CTestJZDlg::OnBnClickedButtonSubtract()
{
	// Z
	// EZ܂B
	// EQ 0xffff0000 - 0xffffffff ԂBIȂz̗vfB
	//   Ȃ킿z̍ővf 0xfffeffff łB
	// Ez̐擪͕\BPȂ}CiXAOȂvX
	// Eez̍ő包͂POiłXƂBȂ킿ő吔 999,999,999 łB
	static const int nMax = 4;
	static int nSwitch = 0;
	
	BOOL  bCorrect;
	ULONG nFigures;
	ULONG nResult;
	LONG  nStart;


	EnableWindow(TRUE);
	nStart = clock();   

	if(nSwitch == 0)
	{
		const ULONG nNa = 8;
		const ULONG nNb = 6;
		ULONG nDa[] = { CM2jz::NEGATIVE,	
						CM2jz::RESERVED,
						   737, 384758364, 762301647, 878576146, 758641765, 465781876 };
		ULONG nDb[] = { CM2jz::POSITIVE,	     
						CM2jz::RESERVED,
					    631463, 781561056, 601346341, 763563186 };
		ULONG nDc[nNa];
		ULONG nAc[] = { CM2jz::NEGATIVE,
						CM2jz::RESERVED,
						   737, 384758364, 761670184,  97015090, 157295423, 702218690 };

		CopyMemory(nDc, nDa, sizeof(ULONG) * nNa);
		nResult  = m_jz.Add(nDa, nNa, nDb, nNb);
		bCorrect = m_jz.Compare(nDa, nNa, nAc, nNa) == 0;

		SetLabels(nSwitch, bCorrect, nStart,clock(), nDa, nNa, nDb, nNb, nDc, nResult);
	}
	else if(nSwitch == 1)
	{
		const ULONG nNa = 6;
		const ULONG nNb = 6;
		ULONG nDa[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
						 0,         0,     62868, 136812637 };
		ULONG nDb[] = { CM2jz::NEGATIVE,
						CM2jz::RESERVED,
						26, 761658136, 516586126, 527168216	};
		ULONG nDc[nNa];
		ULONG nAc[] = { CM2jz::NEGATIVE, 
						CM2jz::RESERVED,
						26, 761658136, 516523258, 390355579 };

		CopyMemory(nDc, nDa, sizeof(ULONG) * nNa);
		nResult  = m_jz.Add(nDc, nNa, nDb, nNb);
		bCorrect = m_jz.Compare(nDc, nNa, nAc, nNa) == 0;

		SetLabels(nSwitch, bCorrect, nStart, clock(), nDa, nNa, nDb, nNb, nDc, nResult);
	}
	else if(nSwitch == 2)
	{
		const ULONG nNa = 6;
		const ULONG nNb = 6;
		ULONG nDa[] = { CM2jz::NEGATIVE,	     
						CM2jz::RESERVED,
					            0,         0,      6164, 716916616 };
		ULONG nDb[] = { CM2jz::POSITIVE,	
						CM2jz::RESERVED,
					    999999999, 271678628, 167612386, 126786136 };
		ULONG nDc[nNa];
		ULONG nAc[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
	  				    999999999, 271678628, 167606221, 409869520 };

		CopyMemory(nDc, nDa, sizeof(ULONG) * nNa);
		nResult  = m_jz.Add(nDc, nNa, nDb, nNb);
		bCorrect = m_jz.Compare(nDc, nNa, nAc, nNa) == 0;

		SetLabels(nSwitch, bCorrect, nStart,clock(), nDa, nNa, nDb, nNb, nDc, nResult);
	}
	else if(nSwitch == 3)
	{
		const ULONG nNa = 12;
		const ULONG nNb = 7;
		const ULONG nNc = nNa;
		ULONG nDa[] = { CM2jz::POSITIVE,	     
						CM2jz::RESERVED,
					          137, 458365713, 637165763, 178653661, 865716386, 371657618,
						653165316, 531653165, 173631651, 375631865 };
		ULONG nDb[] = { CM2jz::NEGATIVE,	
						CM2jz::RESERVED,
						      716, 576176576, 756125465, 156762175, 156555154 };
		ULONG nDc[nNa];
		ULONG nAc[] = { CM2jz::POSITIVE,
						CM2jz::RESERVED,
						      137, 458365713, 637165763, 178653661,	865716386, 371656902,
						 76988739, 775527700,  16869476, 219076711 };

		CopyMemory(nDc, nDa, sizeof(ULONG) * nNa);

		nFigures = m_jz.CheckForFigures(nDa, nNa, 9);
		nFigures = m_jz.CheckForFigures(nDb, nNb, 9);
		nResult  = m_jz.Add(nDc, nNa, nDb, nNb);
		bCorrect = m_jz.Compare(nDc, nNa, nAc, nNa) == 0;

		SetLabels(nSwitch, bCorrect, nStart,clock(), nDa, nNa, nDb, nNb, nDc, nResult);
	}

	if(++nSwitch == nMax)
		nSwitch = 0;

	EnableWindow(TRUE);
}



///////////////////////////////////////////////////////////////////////////////////////////////////
//
// private functions
//
///////////////////////////////////////////////////////////////////////////////////////////////////
void CTestJZDlg::SetLabel(ULONG nN)
{
	LPCTSTR lpszA[] = {	_T("+"), _T("*") };

	m_labMark.SetWindowText(lpszA[nN & 0x1]);
}

void CTestJZDlg::SetLabel(INT nID, ULONG nA[], ULONG nN)
{
	LPCTSTR lpszA[] = {	_T("A = "), 
						_T("ANSWER = "),
						_T("B = "),
						_T(""),
						_T(""),
						_T(""),
						_T("REMAINDER = ")
						_T("") };
	LPCTSTR lpszSpace[] = {	_T("       "),
							_T("                 "),
							_T("       "),
							_T(""),
							_T(""),
							_T(""),
							_T("                      "),
							_T("")	};
	CString strA;
	CString strTmp0, strTmp1;
	INT nP;


	nP = nID - IDC_LABEL_A;

	if(nA == NULL)
	{
		strA = lpszA[nP]; 
	}
	else
	{
		for(ULONG nI = 0; nI < nN; nI++)
		{
			switch(nI)
			{
			case CM2jz::SIGN_POINTER:
				strTmp0 = lpszA[nP];
				if(nN > 1)
					strTmp0 += (nA[nI] == 0)? _T("+ ") : _T("- ");
				break;
			case CM2jz::RESERVED_POINTER:
				strTmp0 = _T("");
				break;
			case CM2jz::NUMERICAL_POINTER:
				strTmp0.Format(_T("%09d\n"), nA[nI]);
				break;
			default:
				strTmp0.Format(_T(" %s%09d\n"), lpszSpace[nP], nA[nI]);
				break;
			}

			strA += strTmp0;
		}
	}

	switch(nID)
	{
	case IDC_LABEL_A:
		m_labA.SetWindowText(strA);
		break;
	case IDC_LABEL_ANSWER:
		m_labAnswer.SetWindowText(strA);
		break;
	case IDC_LABEL_B:
		m_labB.SetWindowText(strA);
		break;
	case IDC_LABEL_REMAINDER:
		m_labRemainder.SetWindowText(strA);
		break;
	}
}

void CTestJZDlg::SetLabels()
{
	m_labCorrect.SetWindowText(_T("CORRECT ="));
	m_labElapsedTime.SetWindowText(_T("ELAPSED TIME ="));
	m_labNumber.SetWindowText(_T("NUMBER ="));
	m_labResult.SetWindowText(_T("RESULT ="));

	SetLabel(IDC_LABEL_A, NULL, 0);
	SetLabel(IDC_LABEL_B, NULL, 0);
	SetLabel(IDC_LABEL_ANSWER, NULL, 0);
	SetLabel(IDC_LABEL_REMAINDER, NULL, 0);	
}

void CTestJZDlg::SetLabels(LONG nStart, LONG nFinish, ULONG nA[], ULONG nNa)
{
	CString strCorrect, strTime, strNumber, strResult;
	DOUBLE  nDuration;


	SetLabels();

	nDuration = (DOUBLE)(nFinish - nStart) / CLOCKS_PER_SEC;
	strTime.Format(_T("ELAPSED TIME = %0.3f seconds"), nDuration);
	m_labElapsedTime.SetWindowText(strTime);	

	SetLabel(IDC_LABEL_A, nA, nNa);
}

void CTestJZDlg::SetLabels(	INT	  nNumber,
							BOOL  bCorrect,
						    LONG  nStart,
							LONG  nFinish,
							ULONG nA[],
							ULONG nNa, 
							ULONG nB[], 
							ULONG nNb,
							ULONG nC[],
							ULONG nNc,
							ULONG nRemainder[],
							ULONG nNr	)
{
	CString strCorrect, strTime, strNumber, strResult;
	DOUBLE  nDuration;


	strCorrect.Format(_T("CORRECT = %d"), bCorrect);
	nDuration = (DOUBLE)(nFinish - nStart) / CLOCKS_PER_SEC;
	strTime.Format(_T("ELAPSED TIME = %0.3f seconds"), nDuration);
	strNumber.Format(_T("NUMBER = %d"), nNumber);
	strResult.Format(_T("RESULT = 0x%08x"), nNc);

	m_labCorrect.SetWindowText(strCorrect);
	m_labElapsedTime.SetWindowText(strTime);
	m_labNumber.SetWindowText(strNumber);
	m_labResult.SetWindowText(strResult);

	if(nNc >= CM2jz::ERR_MIN_SIZE)
	{
		nNc = 1;
		nNr = 1;
	}
	
	SetLabel(IDC_LABEL_A, nA, nNa);
	SetLabel(IDC_LABEL_B, nB, nNb);
	SetLabel(IDC_LABEL_ANSWER, nC, nNc);
	SetLabel(IDC_LABEL_REMAINDER, nRemainder, nNr);	
}
